#include "Game.h"
#include "Image.h"
#include <map>
using namespace std;

#define IDC_EXIT 0
#define IDC_TOGGLEFULLSCREEN 1
#define IDC_HELPURL 2


//==============================================================
// t@CpXoĕԂ
static wstring ExtractFilePath(wstring s) {
	int pos=s.rfind(L"\\");
	if (pos==wstring::npos) return L"";
	return s.substr(0, pos+1);
}


//==============================================================
// HWNDCGameCX^X֘AÂ}bv
typedef map<HWND, CGame*, less<HWND> > THWndCGameMap;
static THWndCGameMap HWndCGameMap;


//==============================================================
// ̃bZ[WnhF
// OtBbNXȂǂ̏Oɂ͂sB
static LRESULT WINAPI DummyWndProc(
	HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam
) {
	return DefWindowProc( hwnd, msg, wparam, lparam );
}


//==============================================================
// bZ[Wnh
static LRESULT WINAPI WndProc(
	HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam
) {
	THWndCGameMap::iterator iter=HWndCGameMap.find(hwnd);
	if (iter==HWndCGameMap.end())
		return DefWindowProc( hwnd, msg, wparam, lparam );
	CGame* game=iter->second;
	return game->WndProc(msg, wparam, lparam);
}

LRESULT WINAPI CGame::WndProc(
	UINT msg, WPARAM wparam, LPARAM lparam
) {
	switch(msg) {

		// `
		case WM_PAINT:
			Draw();
			break;

		// ẽR}h
		case WM_COMMAND:
			switch (LOWORD(wparam)) {

				// I
				case IDC_EXIT:
					DestroyWindow(HWnd);
					return 0;

				// Alt+Returnŉʃ[h؂ւ
				case IDC_TOGGLEFULLSCREEN:
					Graphics->SetFullMode(!Graphics->IsFullMode());
					return 0;

				// wv
				case IDC_HELPURL:
					ShellExecute(HWnd, NULL, HelpURL.c_str(),
    					NULL, NULL, SW_SHOWNORMAL);					
					return 0;
			}
			break;

		// VXeR}h
		case WM_SYSCOMMAND:
			switch (wparam) {

				// ő剻ɂ͉ʃ[h؂ւ
				case SC_MAXIMIZE:
					Graphics->SetFullMode(!Graphics->IsFullMode());
					return 0;					

				// XN[Z[oƃj^dOff̖h~
				case SC_SCREENSAVE:
				case SC_MONITORPOWER:
					return 0;
			}
			break;

		// I
		case WM_DESTROY:
			PostQuitMessage( 0 );
			return 0;
	}
	return DefWindowProc(HWnd, msg, wparam, lparam);
}


//==============================================================
// CGameRXgN^
CGame::CGame(wstring app_name, bool zbuffer)
:	AppName(app_name)
{

	// AvP[VCst@C̃pXAwv̂tqk
	AppName=app_name;
	wchar_t buf[MAX_PATH+1];
	GetModuleFileName(NULL, buf, MAX_PATH);
	ExePath=ExtractFilePath(buf);
	HelpURL=L"";

	// ACR̓ǂݍ
	HINSTANCE hinst=GetModuleHandle(NULL);
	HICON icon=LoadIcon(hinst, L"IDI_GAME");

	// EBhENX̓o^F
	// ł̓_~[̃bZ[Wnho^
	WNDCLASSEX wc={
		sizeof(WNDCLASSEX), CS_CLASSDC, DummyWndProc, 0L, 0L,
		hinst, icon, LoadCursor(NULL, IDC_ARROW), NULL, NULL,
		app_name.c_str(), NULL
	};
	RegisterClassEx(&wc);

	// ANZ[^L[̐ݒF
	// [ESC] : I
	// [Alt]+[Enter] : ʃ[h؂ւ
	// [F1] : wv
	ACCEL accel[]={
		{FVIRTKEY, VK_ESCAPE, IDC_EXIT},
		{FALT|FVIRTKEY, VK_RETURN, IDC_TOGGLEFULLSCREEN},
		{FVIRTKEY, VK_F1, IDC_HELPURL}
	};
	HAccel=CreateAcceleratorTable(
		accel, sizeof(accel)/sizeof(ACCEL));

	// EBhE̍쐬
	HWnd=CreateWindow(
		app_name.c_str(), app_name.c_str(),
		WS_CAPTION|WS_VISIBLE|WS_SYSMENU|WS_MINIMIZEBOX|WS_MAXIMIZEBOX,
		0, 0, 0, 0, GetDesktopWindow(), NULL, wc.hInstance, NULL);
	HWndCGameMap.insert(
		THWndCGameMap::value_type(HWnd, this));

	// OtBbNX̍쐬
	Graphics=new CGraphics(HWnd, true);
	if (!Graphics) {
		MessageBox(HWnd, 
			L"̃vOɂDirectX 9.0ȏオKvłB\n"
			L"DirectX̍ŐVŁAэŐṼhCo\n"
			L"CXg[Ă邩ǂmFB\n"
			L"܂AÑIvVŉ𑜓xύXĂ݂ĂB\n\n"
			L"EBhE800x600AtXN[1024x768̏ꍇF\n"
			L"-w 800 -h 600 -fw 1024 -fh 768",
			app_name.c_str(),
			MB_OK);
		exit(1);
	}

	// C[W̏
	CImage::Init(Graphics->GetDevice());

	// ͂̏
	Input=new CInput(HWnd);
}


//==============================================================
// CGamefXgN^
CGame::~CGame() {
	delete Input;
	CImage::Uninit();
	delete Graphics;
}


//==============================================================
// CGameQ[̎s
void CGame::Run() {

	// _~[̃bZ[WnhC
	// ȃbZ[Wnhɒu
	SetWindowLong(HWnd, GWL_WNDPROC, (long)::WndProc);

	// bZ[W[v
	MSG msg;
	ZeroMemory(&msg, sizeof(msg));
	while (msg.message!=WM_QUIT) {
		if (PeekMessage(&msg, NULL, 0U, 0U, PM_REMOVE)) {
			if (!TranslateAccelerator(HWnd, HAccel, &msg)) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		} else {
			if (HWnd==GetForegroundWindow()) {
				Move();
				Draw();
			}
		}
	}

	// I
	UnregisterClass(AppName.c_str(), GetModuleHandle(NULL));
}

