#pragma once
#include <d3d9.h>
#include <string>
using namespace std;


//==============================================================
// }N
inline int ARGB(int a, int r, int g, int b) {
	return ((a&255)<<24 | (r&255)<<16 |
		(g&255)<<8 | (b&255));
}
inline DWORD ARGB_A(DWORD rgb) { return (rgb)>>24&255; }
inline DWORD ARGB_R(DWORD rgb) { return (rgb)>>16&255; }
inline DWORD ARGB_G(DWORD rgb) { return (rgb)>>8&255; }
inline DWORD ARGB_B(DWORD rgb) { return rgb&255; }


//==============================================================
// _`

// Ǝ̒_`
struct CUSTOMVERTEX
{
	// ϊςݒ_
	FLOAT X, Y, Z, RHW;

	// fBt[YF
	D3DCOLOR Color;

	// eNX`W
	FLOAT TU, TV;
};

// Ǝ̒_`\FVF
#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZRHW|D3DFVF_DIFFUSE|D3DFVF_TEX1)


//==============================================================
// 摜
class CImage {
protected:

	// Direct3DfoCXC_obt@
	static LPDIRECT3DDEVICE9 Device;
	static LPDIRECT3DVERTEXBUFFER9 VertexBuffer;

	// eNX`
	LPDIRECT3DTEXTURE9* Textures;

	// 摜̕CCeNX`iXCYj
	int Width, Height, XCount, YCount;

public:

	// CfoCXԂ̐ݒCI
	static void Init(LPDIRECT3DDEVICE9 device);
	static void SetDeviceState();
	static void Uninit();

	// RXgN^CfXgN^
	CImage(int width, int height);
	~CImage();

	int GetWidth() { return Width; }
	int GetHeight() { return Height; }

	// 摜t@C̃[h
	void LoadFromFile(wstring file_name);

	// `iʍɉ摜ŚjF
	// color͓FiJ[L[j
	void Draw(D3DCOLOR color=0xffffffff) {
		Draw(0, 0, 0, 0, Width, Height, color);
	}

	// `iwʒuɉ摜Śj
	void Draw(int dx, int dy, D3DCOLOR color=0xffffffff) {
		Draw(dx, dy, 0, 0, Width, Height, color);
	}

	// `iwʒuɉ摜̎w蕔j
	void Draw(int dx, int dy, int sx, int sy, int w, int h, 
		D3DCOLOR color=0xffffffff);

	void Clear(D3DCOLOR color=D3DCOLOR_ARGB(0, 0, 0, 0));
};


//==============================================================
// eLXg̐
typedef enum {
	ALIGN_CENTER, 
	ALIGN_LEFT, ALIGN_RIGHT,
	ALIGN_TOP, ALIGN_BOTTOM	
} ALIGN_TYPE;


//==============================================================
// eLXg
class CText : public CImage {
protected:

	// eLXg`pT[tFCX
	LPDIRECT3DSURFACE9 TextSurface;

public:

	// RXgN^CfXgN^
	CText(int width, int height);
	~CText();

	// eLXg̕`
	void DrawText(
		wstring text, int x, int y, 
		D3DCOLOR color, HFONT font,
		ALIGN_TYPE halign=ALIGN_LEFT, 
		ALIGN_TYPE valign=ALIGN_TOP,
		SIZE* psize=NULL
	);

};


