#pragma once

#include <d3dx9.h>
#include <string>
#include "Hit.h"
using namespace std;


//==============================================================
// 蔻̎
typedef enum {
	HIT_ALL, HIT_CORE, NUM_HIT
} HIT_TYPE;


//==============================================================
// r[̎
typedef enum {
	VIEW_TOP, VIEW_SIDE
} VIEW_TYPE;


//==============================================================
// 3DIuWFNg̕\sNX
class CObject3D {
private:

	// bV
	ID3DXMesh* Mesh;

	// }eA̐C}eA
	DWORD NumMaterials;
	D3DMATERIAL9* Materials;

	// eNX`
	LPDIRECT3DTEXTURE9* Textures;

	// 蔻
	CHit Hit[NUM_HIT];

	// \[h
	static VIEW_TYPE ViewType;

	// foCX
	static LPDIRECT3DDEVICE9 Device;

	// foCXԂ̐ݒ
	static void SetDeviceState_Common();
	static void SetDeviceState_TopView();
	static void SetDeviceState_SideView();
	static float RotationRad;

	// Cg̏
	static void InitLight(
		D3DLIGHT9& light, D3DLIGHTTYPE type, 
		FLOAT x, FLOAT y, FLOAT z);

	// obNobt@̃TCY𓾂
	static SIZE GetBackBufferSize();

	// gbvr[݂̂ǂ
	bool TopViewOnly;

public:

	// RXgN^CfXgN^
	CObject3D();
	~CObject3D();

	// t@C̓ǂݍ
	CObject3D* LoadFromFile(wstring file);

	// `
	void Draw(float alpha, bool alpha_addition);
	void Draw(float x, float y, float z);
	void DrawTopView(float x, float y, 
		float sx, float sy, 
		float yaw, float pitch, float roll,
		float alpha, bool alpha_addition);
	void DrawTopView(float x, float y, float z,
		float sx, float sy, 
		float yaw, float pitch, float roll,
		float alpha, bool alpha_addition);
	void Draw(
		D3DXMATRIX& mat,		
		float x, float y, float z, 
		float sx, float sy, float sz,
		float rx, float ry, float rz,
		float alpha, bool alpha_addition);

	// 蔻
	CObject3D* SetHit(HIT_TYPE type, const CHit& hit);
	CHit GetHit(HIT_TYPE type);

	void SetTopViewOnly(bool tv_only) { TopViewOnly=tv_only; }

	// CI
	static void Init(LPDIRECT3DDEVICE9 device);
	static void Uninit();

	// \[hCfoCXԂ̐ݒ
	static void SetViewType(VIEW_TYPE view_type) { ViewType=view_type; }
	static void SetDeviceState();
	static void SetRotation(float angle);
};

